// SWERC 2014, Problem: Safe Secret
// Approach: Dynamic Programming. O(n^3).
// Author: Miguel Oliveira
#include <climits>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
using namespace std;
const int MAX = 2 * 200 + 2;

long long dp_max[MAX][MAX], dp_min[MAX][MAX];
char op[MAX];

int main() {
  int i, j, k, size, number, n;
  scanf("%d", &n);
  for (i = 0; i < n; i++) {
    scanf("%d %c", &number, &op[i]);
    op[i+n] = op[i];
    dp_min[i][i] = dp_max[i][i] = dp_min[i+n][i+n] = dp_max[i+n][i+n] = number;
  }
  for (size = 1; size < n; size++) {
    for (i = 0, j = i+size; j < 2*n; i++, j++) {
      dp_min[i][j] = LLONG_MAX, dp_max[i][j] = LLONG_MIN;
      // Interval [i, j = i+size], split into 2 intervals using position k.
      for (k = i; k < j; k++) {
        if (op[k] == '+' || op[k] == '?') {           // Addition
          dp_max[i][j] = max(dp_max[i][j], dp_max[i][k] + dp_max[k+1][j]);
          dp_min[i][j] = min(dp_min[i][j], dp_min[i][k] + dp_min[k+1][j]);
        }
        if (op[k] == '-' || op[k] == '?') {           // Subtraction
          dp_max[i][j] = max(dp_max[i][j], dp_max[i][k] - dp_min[k+1][j]);
          dp_min[i][j] = min(dp_min[i][j], dp_min[i][k] - dp_max[k+1][j]);
        }
        if (op[k] == '*' || op[k] == '?') {           // Multiplication
          // (max1 * max2) or (min1 * min2) or (max1 * min2) or (min1 * max2)
          dp_max[i][j] = max(dp_max[i][j], max(dp_max[i][k] * dp_max[k+1][j], dp_min[i][k] * dp_min[k+1][j]));
          dp_max[i][j] = max(dp_max[i][j], max(dp_max[i][k] * dp_min[k+1][j], dp_min[i][k] * dp_max[k+1][j]));
          dp_min[i][j] = min(dp_min[i][j], min(dp_min[i][k] * dp_min[k+1][j], dp_max[i][k] * dp_min[k+1][j]));
          dp_min[i][j] = min(dp_min[i][j], min(dp_min[i][k] * dp_max[k+1][j], dp_max[i][k] * dp_max[k+1][j]));
        }
      }
    }
  }
  for (i = 0; i < n; i++) 
    printf("%lld%lld", abs(dp_min[i][n+i-1]), abs(dp_max[i][n+i-1]));
  puts("");
  return 0;
}
